import 'dart:convert';

import 'package:speedq_net/entities/OrderItem.dart';
import 'package:speedq_net/src/util/JsonReflector.dart';

@reflector
class Order {
    late String id;
    late String customerId;
    late String stallId;
    late String dateTime;
    late int code;
    late int status;
    late _Stall stall;
    late int total;
    late List<OrderItem> items;

    Order.fromJson(String json) {
        Map<String, dynamic> map = jsonDecode(json);
        id = map["id"];
        customerId = map["cust_id"];
        stallId = map["stall_id"];
        dateTime = map["datetime"];
        code = map["code"];
        status = map["status"];
        stall = _Stall.fromJson(map["stall"]);
        total = map["total"];
        items = (map["items"] as List).map((item) => OrderItem.fromJsonMap(item)).toList();
    }

    Order.fromJsonMap(Map json) {
        id = json["id"];
        customerId = json["cust_id"];
        stallId = json["stall_id"];
        dateTime = json["datetime"];
        code = json["code"];
        status = json["status"];
        stall = _Stall.fromJson(json["stall"]);
        total = json["total"];
        items = (json["items"] as List).map((item) => OrderItem.fromJsonMap(item)).toList();
    }
}

class _Stall {
    late String name;
    late _FoodCourt foodCourt;

    _Stall.fromJson(Map json) {
        name = json["name"];
        foodCourt = _FoodCourt.fromJson(json["food_court"]);
    }
}

class _FoodCourt {
    late String name;

    _FoodCourt.fromJson(Map json) {
        name = json["name"];
    }
}