import 'dart:convert';

import 'package:hive/hive.dart';
import 'package:speedq_net/src/util/JsonReflector.dart';

part 'TokenResponse.g.dart';

/// represents a response from server authentication
@reflector
@HiveType(typeId: 8)
class TokenResponse {
    /// user id
    @HiveField(0)
    late String id;
    /// access token
    @HiveField(1)
    late String access;
    /// refresh token
    @HiveField(2)
    late String refresh;

    TokenResponse(this.id, this.access, this.refresh);

  /// json constructor
    TokenResponse.fromJson(String json) {
        Map<String, dynamic> map = jsonDecode(json);
        id = map["id"];
        access = map["access"];
        refresh = map["refresh"];
    }

    TokenResponse.fromJsonMap(Map json) {
        id = json["id"];
        access = json["access"];
        refresh = json["refresh"];
    }
}